// MSFClassDlg.cpp : implementation file
//

#include "stdafx.h"
#include "MSFClass.h"
#include "MSFClassDlg.h"
#include "Windows.h"
#include "Passwords.h"
#include "Decrypt.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// CMSFClassDlg dialog

CMSFClassDlg::CMSFClassDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMSFClassDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
	CListBox m_hList;
}

void CMSFClassDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_LIST3, m_hList);
	DDX_Control(pDX, IDC_BUTTON2, LnkEmail);
	DDX_Control(pDX, IDC_BUTTON3, LnkWebsite);
	DDX_Control(pDX, IDC_EXPLORE, LnkExplore);
}

BEGIN_MESSAGE_MAP(CMSFClassDlg, CDialog)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_BUTTON1, OnBnClickedButton1)
	ON_BN_CLICKED(IDOK, OnBnClickedOk)
	ON_BN_CLICKED(IDCANCEL, OnBnClickedCancel)
	ON_BN_CLICKED(IDC_BUTTON2, OnBnClickedButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnBnClickedButton3)
	ON_BN_CLICKED(IDC_EXPLORE, OnBnClickedExplore)
//	ON_WM_SETFOCUS()
//	ON_WM_KILLFOCUS()
ON_WM_ACTIVATE()
//ON_WM_KILLFOCUS()
END_MESSAGE_MAP()


// CMSFClassDlg message handlers

BOOL CMSFClassDlg::OnInitDialog()
{
	char sFilename[32];
	CDialog::OnInitDialog();
	int	nCountMax;

//	LnkEmail.SubclassDlgItem(IDC_BUTTON2, this);


	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	// initialize the big icon control
	m_picture.SubclassDlgItem(IDC_TFPICON, this);
	m_picture.LoadPicture();


	// TODO: Add extra initialization here
	LoadFileList ();

	nCountMax = DecFLGetNum ();
//char * DecFLGetLeafname (int nIndex)

	for (int n=0; n < nCountMax; n++)
	{
		sprintf (sFilename, "%s", DecFLGetLeafname (n));
		m_hList.AddString (sFilename);
	}

	m_hList.SetCurSel (0);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CMSFClassDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, reinterpret_cast<WPARAM>(dc.GetSafeHdc()), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this function to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMSFClassDlg::OnQueryDragIcon()
{
	return static_cast<HCURSOR>(m_hIcon);
}

void CMSFClassDlg::OnLvnItemchangedList1(NMHDR *pNMHDR, LRESULT *pResult)
{
}

void CMSFClassDlg::OnBnClickedButton1()
{
	char	szSelected[_MAX_PATH];
	char	szFullPath[_MAX_PATH];
	char	szFilter[255];
	int		nLength;
	char	*szExtension;
	char	*szConvert;
	char	szExt[32];
	bool	boOkay;
	Passwords	dlgPasswords;
	// TODO: Add your control notification handler code here

	// Find out about the selected file

	DecFLStoreKeyPress (m_hList.GetCurSel ());

	m_hList.GetText(m_hList.GetCurSel (), szSelected);
	nLength = (int)strlen (szSelected);

	// Open the Save As dialogue box
	CFileDialog dlgFile(false);
	dlgFile.m_ofn.Flags |= (OFN_NONETWORKBUTTON | OFN_OVERWRITEPROMPT | OFN_PATHMUSTEXIST | OFN_ENABLESIZING);
	dlgFile.m_ofn.lpstrFile = szSelected;

	szExtension = strchr(szSelected,'.');

	if (szExtension)
	{
		_snprintf(szFilter, sizeof(szFilter), "%s files (*.%s)\n*.%s\nAll files (*.*)\n*.*\n\n", szExtension+1, szExtension+1, szExtension+1);
	}
	else
	{
		_snprintf(szFilter, sizeof(szFilter), "All files (*.*)\n*.*\n\n");
	}

	szConvert = strchr(szFilter, '\n');
	while (szConvert)
	{
		*szConvert = '\0';
		szConvert = strchr(szConvert+1, '\n');
	}



	dlgFile.m_ofn.lpstrFilter = szFilter;
	_snprintf (szExt, sizeof(szExt), "%s", szExtension);
	dlgFile.m_ofn.lpstrDefExt = szExt;


	boOkay = (dlgFile.DoModal() == IDOK);

	if (boOkay)
	{
		strncpy (szFullPath, dlgFile.GetPathName (), sizeof(szFullPath));
		DecryptSetPath (szFullPath);

		EndDialog (0);
		dlgPasswords.DoModal ();
	}

}

void CMSFClassDlg::OnBnClickedOk()
{
	// TODO: Add your control notification handler code here
	OnOK();
}

void CMSFClassDlg::OnBnClickedCancel()
{
	// TODO: Add your control notification handler code here
	OnCancel();
}

/////////////////////////////////////////////////////////////////////////////
// CPicture

BEGIN_MESSAGE_MAP(CPicture, CButton)
	//{{AFX_MSG_MAP(CPicture)
	ON_WM_DRAWITEM()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CPicture::LoadPicture()
{
	m_bitmap.LoadBitmap(IDB_TFP);
	m_mask.LoadBitmap(IDB_MASK);
	BITMAP bm;
	m_bitmap.GetObject(sizeof(bm), &bm);
	m_sizeBitmap = CSize(bm.bmWidth, bm.bmHeight);
	// get system icon size

	// a big icon should be twice the size of an icon + shadows
//	SetWindowPos(NULL, 0, 0, bm.bmWidth + CX_SHADOW + 4, bm.bmHeight + CY_SHADOW + 4,
//		SWP_NOACTIVATE|SWP_NOMOVE|SWP_NOZORDER);
}

void CPicture::DrawItem(LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	CDC* pDC = CDC::FromHandle(lpDrawItemStruct->hDC);
	ASSERT(pDC != NULL);

	CRect rect;
	GetClientRect(rect);
	int cxClient = rect.Width();
	int cyClient = rect.Height();

	// draw border around icon
//	CPen pen;
//	pen.CreateStockObject(BLACK_PEN);
//	CPen* pPenOld = pDC->SelectObject(&pen);
//	pDC->Rectangle(0, 0, cxClient-CX_SHADOW, cyClient-CY_SHADOW);
//	if (pPenOld)
//		pDC->SelectObject(pPenOld);

	// draw shadows around icon
//	CBrush br;
//	br.CreateStockObject(DKGRAY_BRUSH);
//	rect.SetRect(cxClient-CX_SHADOW, CY_SHADOW, cxClient, cyClient);
//	pDC->FillRect(rect, &br);
//	rect.SetRect(CX_SHADOW, cyClient-CY_SHADOW, cxClient, cyClient);
//	pDC->FillRect(rect, &br);

	// draw the bitmap contents
	CDC dcMem;
	if (!dcMem.CreateCompatibleDC(pDC))
		return;
	CBitmap* pBitmapOld = dcMem.SelectObject(&m_bitmap);
	if (pBitmapOld == NULL)
		return;

//	pDC->BitBlt(2, 2, m_sizeBitmap.cx, m_sizeBitmap.cy, &dcMem, 0, 0, SRCCOPY);

	pDC->MaskBlt((cxClient - m_sizeBitmap.cx)/2, (cyClient - m_sizeBitmap.cy)/2, m_sizeBitmap.cx, m_sizeBitmap.cy, &dcMem, 0, 0, m_mask, 0, 0, MAKEROP4 (SRCAND, SRCCOPY));
/*
	int x,
   int y,
   int nWidth,
   int nHeight,
   CDC* pSrcDC,
   int xSrc,
   int ySrc,
   CBitmap& maskBitmap,
   int xMask,
   int yMask,
   DWORD dwRop 
);*/

	dcMem.SelectObject(pBitmapOld);
}

BOOL CPicture::OnEraseBkgnd(CDC*)
{
	return TRUE;    // we don't do any erasing...
}

void CMSFClassDlg::OnBnClickedButton2()
{
	// TODO: Add your control notification handler code here

	// Launch email
	ShellExecute(NULL,"","mailto:david@flypig.co.uk","","",SW_SHOWNORMAL);
}

void CMSFClassDlg::OnBnClickedButton3()
{
	char * szPath;
	// TODO: Add your control notification handler code here
	szPath = DecryptGetRoot ();

	// Launch website
	ShellExecute(NULL,"","Website\\Begin.htm","",szPath,SW_SHOWNORMAL);
}

void CMSFClassDlg::OnBnClickedExplore()
{
	char * szPath;
	// TODO: Add your control notification handler code here
	szPath = DecryptGetRoot ();

	// Explore CD
	ShellExecute(NULL,"explore",szPath,"","",SW_SHOWNORMAL);
}

void CMSFClassDlg::OnActivate(UINT nState, CWnd* pWndOther, BOOL bMinimized)
{
	CDialog::OnActivate(nState, pWndOther, bMinimized);
	// TODO: Add your message handler code here
	if (nState == WA_INACTIVE)
	{
		LnkExplore.Reset ();
		LnkEmail.Reset ();
		LnkWebsite.Reset ();
	}
}

